<template>
  <div class="d-flex flex-col flex-1 flex-as-stretch" style="background: white"
    v-if="msgUser">
    <div class="navbar d-flex flex-ai-center p-3">
      <img :src="msgUser.media[0]" class="profile-pic mr-1">
      <span class="text-bold text-left ml-1" @click="showProfile">
        {{ msgUser.name.first }}
        <span v-if="!msgUser.online" class="text-secondary text-small"> - Last active {{ seenAgo }} ago</span>
        <span v-else class="text-secondary text-small"> - Active</span>
      </span>
      <!-- <span class="text-muted ml-1 text-small">
      </span> -->
      <button class="icon-button ml-auto text-muted"
        @click="$store.commit('setMsgUser', null)">
        <v-icon>
          <v-icon name="times"/>
          <v-icon name="regular/circle" scale="2"/>
        </v-icon>
      </button>
    </div>
    <div class="d-flex flex-col flex-1 messages-view" ref="mview">
      <Message v-for="msg of currentMessages" :key="msg._id" :message="msg"/>
      <div v-if="currentMessages.length === 0" class="d-flex flex-col m-auto">
        <h3 class="mb-0">You Matched with {{ msgUser.name.first }}</h3>
        <span>{{ matchAgo }} ago</span>
        <img :src="msgUser.media[0]" class="profile-pic big">
        <span class="mt-5">Next level reached!</span>
      </div>
    </div>
    <form class="d-flex flex-row flex-jc-center input-container p-2"
      @submit="sendMessage">
      <input type="text" class="flex-1" v-model="message">
      <button class="primary ml-1" type="submit">Send</button>
    </form>
  </div>
</template>

<script>
import { mapState, mapGetters } from 'vuex';
import { timeSince } from '@/modules/moment';
import axios from 'axios';
import Vue from 'vue';
import Message from '@/components/Message.vue';

export default {
  data: () => ({
    message: null,

    _unwatch: null,
    seenAgo: null,
  }),
  props: {
  },
  components: {
    Message,
  },
  computed: {
    ...mapState(['msgUser', 'messages', 'user']),
    ...mapGetters(['currentMessages']),
    matchAgo() {
      return timeSince(this.msgUser.match.since);
    },
  },
  watch: {
    /**
     * On msgUser change
     */
    msgUser(to) {
      // Disconnect any previos watchers
      if (this._unwatch) {
        this._unwatch();
        this._unwatch = null;
      }
      // If changed to null (user closed messages tab) just return
      if (!to) return;
      // In the new approach components don't get messages themselves. The store
      // and bus systems handle all the message sending and receiving

      this._unwatch =
        // Watch message changes for the current conversation
        this.$store.watch(s => s.matches[to._id].messages, () => {
          this.scrollBottom();
          this.readAll();
        });

      // This call ensures the messages are at the bottom as soon as they are
      // opened up by the user
      setTimeout(() => { this.scrollBottom(); }, 0);
      // Messages are automatically read
      this.readAll();
    },
  },
  methods: {
    /**
     * Send the message
     * - validate the text
     * - (async) make the post request
     * - reset text input
     */
    sendMessage(e) {
      e.preventDefault();

      if (!this.msgUser || !this.message || /^\s+$/.test(this.message))
        return;

      axios.post(`/api/message/to/${this.msgUser._id}`, {
        text: this.message,
      })
        .catch((err) => err);

      this.message = null;
    },
    /**
     * Set any unread messages as read (also in the server)
     */
    readAll() {
      let _messages = this.currentMessages;
      // In the unlikely event that there are no messages for the current user
      // simply return
      if (!_messages)
        return;
      // Check if there are any unread messages sent by them
      let any = false;
      // Set all incoming messages from them to true in the store
      _messages.forEach((m, i) => {
        if (m.read || m.to !== this.user._id) return;
        any = true;
        Vue.set(this.$store.state.matches[this.msgUser._id].messages[i], 'read', true);
      });
      // Send the update to the server
      if (any)
        axios.post(`/api/message/read_all/${this.msgUser._id}`)
          .catch((err) => err);
    },
    /**
     * Scroll messages view to bottom
     */
    scrollBottom() {
      let el = this.$refs.mview;
      if (el)
        el.scrollTo(0, el.scrollHeight);
    },
    /**
     * Set store.showProfile = true
     */
    showProfile() {
      Vue.set(this.$store.state, 'viewProfile', true);
    },
  },
  mounted() {
    // Hack to update time
    setInterval(() => {
      if (this.msgUser)
        this.seenAgo = timeSince(new Date(this.msgUser.last_active));
    }, 100);
  },
};
</script>

<style scoped>
.navbar {
  border-bottom: 1px solid #e8e8e8;
}

.profile-pic {
  width: 44px;
  height: 44px;
  object-fit: cover;
  border-radius: 50%;
  box-shadow: 0 2px 5px 0 rgba(0,0,0,0.28);

  border: 2px solid white;
}

.profile-pic.big {
  width: 210px;
  height: 210px;
  max-width: 100%;
  margin: 1em auto;
  box-shadow: none;
  border: 0;
}

.input-container {
  border-top: 1px solid #e8e8e8;
  height: 75px;
}

input {
  border: none;
  min-width: 0;
  padding: 1em 2em;
}

.messages-view {
  overflow-y: auto;
}

.messages-view::before,
.messages-view::after {
  flex: 0 0 1em;
  content: '';
}

.messages-view .message.mine + .message:not(.mine),
.messages-view .message:not(.mine) + .message.mine {
  margin-top: 1em;
}

</style>
